/*
 * Copyright (C) 2008 Luke Kenneth Casson Leighton <lkcl@lkcl.net>
 * Copyright (C) 2008 Alp Toker <alp@atoker.com>
 * Copyright (C) 2008 Apple Inc.
 */
#ifndef __GdomKeyboardEvent_H__
#define __GdomKeyboardEvent_H__
#include <webkit/webkitdefines.h>
#include "gdom/GdomDOMWindow.h"
#include "gdom/GdomUIEvent.h"
#include "glib-object.h"


G_BEGIN_DECLS

typedef struct _GdomKeyboardEvent GdomKeyboardEvent;
typedef struct _GdomKeyboardEventClass GdomKeyboardEventClass;


#define GDOM_TYPE_KEYBOARD_EVENT            (gdom_keyboard_event_get_type())
#define GDOM_KEYBOARD_EVENT(obj)            (G_TYPE_CHECK_INSTANCE_CAST((obj), GDOM_TYPE_KEYBOARD_EVENT, GdomKeyboardEvent))
#define GDOM_KEYBOARD_EVENT_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST((klass),  GDOM_TYPE_KEYBOARD_EVENT, GdomKeyboardEvent)Class)
#define GDOM_IS_KEYBOARD_EVENT(obj)         (G_TYPE_CHECK_INSTANCE_TYPE((obj), GDOM_TYPE_KEYBOARD_EVENT))
#define GDOM_IS_KEYBOARD_EVENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((klass),  GDOM_TYPE_KEYBOARD_EVENT))
#define GDOM_KEYBOARD_EVENT_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS((obj),  GDOM_TYPE_KEYBOARD_EVENT, GdomKeyboardEventClass))

typedef struct _GdomKeyboardEventPrivate GdomKeyboardEventPrivate;

struct _GdomKeyboardEvent {
    GdomUIEvent parent_instance;
    GdomKeyboardEventPrivate *priv;
};

struct _GdomKeyboardEventClass {
    GObjectClass parent_class;
};

WEBKIT_API GType
gdom_keyboard_event_get_type (void);

WEBKIT_API gboolean
gdom_keyboard_event_get_modifier_state (GdomKeyboardEvent *thiz, gchar * key_identifier_arg);

WEBKIT_API void
gdom_keyboard_event_init_keyboard_event (GdomKeyboardEvent *thiz, gchar * type, gboolean can_bubble, gboolean cancelable, GdomDOMWindow * view, gchar * key_identifier, gulong key_location, gboolean ctrl_key, gboolean alt_key, gboolean shift_key, gboolean meta_key, gboolean alt_graph_key);

G_END_DECLS

#endif /* __GdomKeyboardEvent_H__ */
